<?php

$GSPObj = new GSP();

class GSP
{

    public $mDb;
    public $mConfig;
    public $lang;
    public $dateTime;
    public $mPrefix;

    public function GSP()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->lang = LANGUAGE;
        $this->dateTime = date('Y-m-d H:i:s');
    }

    public function checkSearchWord($id, $word)
    {
        $sql = "SELECT * FROM `not_if_add` WHERE `user_id` = :id AND `search_product` = :word";
        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':id', $id, PDO::PARAM_STR);
        $query->bindParam(':word', $word, PDO::PARAM_STR);
        $query->execute();
        return $query->fetch(PDO::FETCH_ASSOC);
    }
    public function Insert_Search_Word($id, $word, $facility_id)
    {
        $sql = "INSERT INTO `not_if_add` (`user_id`, `search_product`, `facility_id`) VALUES (:id, :word,:facility_id)";
        $query = $this->mDb->connect()->prepare($sql);
        $query->bindParam(':id', $id, PDO::PARAM_STR);
        $query->bindParam(':word', $word, PDO::PARAM_STR);
        $query->bindParam(':facility_id', $facility_id, PDO::PARAM_STR);
        return $query->execute();
    }
}
