<?php

$subsObj = new subs();

class subs
{

    public $mDb;
    public $mConfig;
    public $lang;
    public $dateTime;
    public $mPrefix;

    public function subs()
    {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->mPrefix = $Config['prefix'];
        $this->lang = LANGUAGE;
        $this->dateTime = date('Y-m-d H:i:s');
    }
    public function getSubsDetails($id)
    {
        $EX = 33;
        $sql = "SELECT pwl.title
            FROM `payment_way_langs` pwl
            LEFT JOIN `payment_ways` s ON s.id = pwl.payment_way_id
            WHERE `payment_way_id` = :id AND pwl.lang_code = '" . LANGUAGE . "'";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $EX, PDO::PARAM_INT);
        $stmt->execute();
        $title = $stmt->fetch(PDO::FETCH_ASSOC);

        $sql1 = "SELECT * FROM `subscriptions` s
                 WHERE `user_id` = :id
                 ORDER BY id DESC ";

        $stmt1 = $this->mDb->connect()->prepare($sql1);
        $stmt1->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt1->execute();

        $subs = $stmt1->fetchAll(PDO::FETCH_ASSOC);
        foreach ($subs as $sub) {
            if (date_offeset) {
                $dt = new DateTime();
                $dt->setTimestamp(strtotime($sub['date_from']));
                $dt->setTimezone(new DateTimeZone(date_offeset));
                $sub['date_from'] = $dt->format('Y-m-d H:i:s');
            }
            if (date_offeset) {
                $dt = new DateTime();
                $dt->setTimestamp(strtotime($sub['date_to']));
                $dt->setTimezone(new DateTimeZone(date_offeset));
                $sub['date_to'] = $dt->format('Y-m-d H:i:s');
            }
        }
        $name = "subscription_price";
        $sql2 = "SELECT ss.value FROM `settings` ss
                 WHERE `name` = :name ";

        $stmt2 = $this->mDb->connect()->prepare($sql2);
        $stmt2->bindParam(':name', $name, PDO::PARAM_STR);
        $stmt2->execute();
        $price = $stmt2->fetch(PDO::FETCH_ASSOC);

        $sql3 = "SELECT `date_to` FROM `subscriptions`
            WHERE `user_id` = :id
            ORDER BY id DESC
            LIMIT 1";

        $stmt3 = $this->mDb->connect()->prepare($sql3);
        $stmt3->bindParam(':id', $id, PDO::PARAM_INT);
        $stmt3->execute();

        $res3 = $stmt3->fetch(PDO::FETCH_ASSOC);
        if (date_offeset) {
            $dt = new DateTime();
            $dt->setTimestamp(strtotime($res3['date_to']));
            $dt->setTimezone(new DateTimeZone(date_offeset));
            $res3['date_to'] = $dt->format('Y-m-d H:i:s');
        }

        return [
            'payment_way' => $title['title'] ?? '',
            'price' => $price['value'] ?? '',
            'subs' => $subs,
            'end_date' => $res3['date_to'] ?? '',
        ];
    }

}
