<?php

require_once 'init.php';
if ($_GET['action'] == 'getPostDetails' && $_SERVER['REQUEST_METHOD'] === 'POST') {

    $comment_id = ($Req['comment_id']) ? $Req['comment_id'] : '';
    $user = $user_init['id'] ? $user_init['id'] : 1;
    $data = $postObj->getPostDetails($Req['post_id'], $user, $comment_id);
    if ($data) {
        $Data['data'] = $data;
        $Data['success'] = true;
    } else {
        $Data['data'] = [];
        $Data['error'] = 'noContent';
        $Data['success'] = false;
    }

} elseif ($_GET['action'] == 'getcommentsByPostId' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $Req['start'] = isset($Req['start']) ? $Req['start'] : "0";
    $Req['limit'] = isset($Req['limit']) ? $Req['limit'] : "21";
    $user = $user_init['id'] ? $user_init['id'] : "";
    $data = $postObj->getcommentsByPostId($user, $Req['post_id'], $Req['start'], $Req['limit'], 'comment');
    if ($data) {
        $Data['data'] = $data;
        $Data['success'] = true;
    } else {
        $Data['data'] = [];
        $Data['success'] = false;
        $Data['error'] = 'noContent';
    }
} elseif ($_GET['action'] == 'getProfilePosts' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $limit = ($Req['limit']) ? $Req['limit'] : '5';
    $start = ($Req['start']) ? $Req['start'] : '0';
    $user = $user_init['id'] ? $user_init['id'] : '';
    $product_name = ($Req['product_name']) ? $Req['product_name'] : '';
    $data = $postObj->getProfilePosts($user, $Req['id'], $start, $limit, $product_name);

    if ($data) {
        $Data['data'] = $data;
        $Data['success'] = true;
    } else {
        $Data['data'] = [];
        $Data['error'] = 'noContent';
        $Data['success'] = false;
    }
} elseif ($_GET['action'] == 'getNearbyPosts' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $start = ($Req['start']) ? $Req['start'] : '0';
    $limit = ($Req['limit']) ? $Req['limit'] : '10';
    $data = $postObj->getNearbyPosts($user_init['id'], $start, $limit, $Req['product_name'], $Req['lat'], $Req['lon']);
    if ($data) {
        $Data['data'] = $data;
        $Data['success'] = true;
    } else {
        $Data['data'] = [];
        $Data['success'] = false;
        $Data['error'] = 'noContent';
    }
} elseif ($_GET['action'] == 'addEditPost' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $isAdd = !$Req['post_id'];
    $isPost = $Req['type'] == 'post';
    $isVideo = $Req['type'] == 'video';
    $isImage = $Req['type'] == 'image';
    $hasContent = $Req['description'] || $Req['product_name'];

    if ($isAdd) {
        if (($user_init['subscriptions_hide'] == 1) || ($user_init['is_subs'] == 1 || (($user_init['post'] == 0 && $isPost) || ($user_init['post_video'] == 0 && $isVideo) || ($user_init['post_img'] == 0 && $isImage)))) {
            if ($hasContent || $isVideo || $isImage || $isPost) {
                if ($isPost) {
                    $data = $postObj->addPost($user_init['user_id'], $user_init['id'], $Req);
                } elseif ($isVideo) {
                    $data = $postObj->addVideo($user_init['user_id'], $user_init['id'], $Req);
                } elseif ($isImage) {
                    $data = $postObj->addImage($user_init['user_id'], $user_init['id'], $Req);
                }

                if ($data) {
                    if ($user_init['is_subs'] == "0" && $user_init['subscriptions_hide'] == "0") {
                        $postObj->update_post_status($user_init['id'], $Req['type']);
                        $postObj->updatepostinfree($user_init['id'], $data['id']);
                    }
                    $Data['data'] = $data;
                    $Data['success'] = true;
                } else {
                    $Data['error'] = 'someErrorHappen';
                    $Data['success'] = false;
                }
            } else {
                $Data['error'] = 'يرجى اضافة محتوى';
                $Data['success'] = false;
            }
        } else {
            $Data['error'] = 'you_have_to_upgrade_your_acc';
            $Data['success'] = false;
        }
    } else {
        if ($isPost) {
            $data = $postObj->editPost($user_init['id'], $Req);
        } elseif ($isVideo) {
            $data = $postObj->edit_video($user_init['id'], $Req);
        } elseif ($isImage) {
            $data = $postObj->edit_image($user_init['id'], $Req);
        }

        if ($data) {
            $Data['success'] = true;
            $Data['message'] = $Req['type'] . '_updated_successfully';
        } else {
            $Data['success'] = false;
            $Data['error'] = 'true';
        }
    }
} elseif ($_GET['action'] == 'pin_Post' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $check = $postObj->checkPinPost($Req['post_id'], $user_init['id']);
    if ($check == 1) {
        $data = $postObj->unpin_Post($Req['post_id'], $user_init['id']);
        if ($data) {
            $Data['success'] = true;
            $Data['data'] = "delete";
        } else {
            $Data['success'] = false;
            $Data['error'] = "true";
        }
    } elseif ($check == 0) {
        $data = $postObj->pin_Post($Req['post_id'], $user_init['id']);
        if ($data) {
            $Data['success'] = true;
            $Data['data'] = "add";
        } else {
            $Data['success'] = false;
            $Data['error'] = "you_have_one_post_pinned_from_the_same_type";
        }
    }
} elseif ($_GET['action'] == 'deletePost' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $data = $postObj->deletePost($Req['post_id'], $user_init['id']);
    if ($data) {
        $Data['success'] = true;
    } else {
        $Data['success'] = false;
    }
} elseif ($_GET['action'] == 'addComment' && $_SERVER['REQUEST_METHOD'] === 'POST') {

    $parent_id = $Req['parent_id'] ? $Req['parent_id'] : '0';
    $Req['img'] = $Req['img'] ? $Req['img'] : '';
    $Req['description'] = $Req['description'] ? $Req['description'] : '';

    if (!$Req['description'] && !$Req['img']) {
        $Data['error'] = 'There is no content';
        $Data['success'] = false;
    } else {
        $data = $postObj->addComment($parent_id, $user_init['id'], $Req);
        if ($data) {
            $Data['data'] = $data;
            $Data['success'] = true;
        } else {
            $Data['error'] = 'someErrorHappen';
            $Data['success'] = false;
        }
    }
} elseif ($_GET['action'] == 'deleteComment' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $data = $postObj->deleteComment($user_init['id'], $Req);
    if ($data) {
        $Data['success'] = true;
    } else {
        $Data['error'] = "true";
        $Data['success'] = false;
    }
} elseif ($_GET['action'] == 'editComment' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    if (!$Req['description'] && !$Req['img']) {
        $Data['error'] = 'There is no content';
        $Data['success'] = false;
    } else {
        $data = $postObj->editComment($Req, $user_init['id']);
        if ($data) {
            $Data['data'] = $data;
            $Data['success'] = true;
        } else {
            $Data['error'] = 'someErrorHappen';
            $Data['success'] = false;
        }
    }
} elseif ($_GET['action'] == 'getReportingReasons' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $data = $postObj->getReportingReasons();
    if ($data) {
        $Data['data'] = $data;
        $Data['success'] = true;
    } else {
        $Data['error'] = 'noContent';
        $Data['success'] = false;
    }
} elseif ($_GET['action'] == 'userAddContentReport' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $user_id = $user_init['id'];
    $data = $postObj->userAddContentReport($user_id, $Req);
    if ($data) {
        $Data['data'] = $data;
        $Data['success'] = true;
    } else {
        $Data['error'] = 'noContent';
        $Data['success'] = false;
    }
} elseif ($_GET['action'] == 'increaseVideoViews' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $data = $postObj->increaseVideoViews($Req['video_id']);
    if ($data) {
        $Data['data'] = $data;
        $Data['success'] = true;
    } else {
        $Data['error'] = 'noContent';
        $Data['success'] = false;
    }
} elseif ($_GET['action'] == 'likeOrDisLike' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $res = $postObj->checkPostOrCommentOrReplayByUser_idAndType($Req['node_id'], $user_init['id'], 'like', $Req['is_on']);

    if ($res) {
        $data = $postObj->deletelike($Req['node_id'], $user_init['id'], 'like', $Req['is_on']);
        $Data['data'] = 'delete';
        $Data['success'] = true;
    } else {
        $data = $postObj->addlike($Req['node_id'], $user_init['id'], 'like', $Req['is_on']);
        $Data['success'] = true;
        $Data['data'] = 'add';
    }
} elseif ($_GET['action'] == 'sendFawryApiInfo') {

    $opts = array('http' => array(
        'method' => 'POST',
        'header' => 'Content-type: application/json',
        'content' => $Req['fawryApiInfo'],
    ));
    # Create the context
    $context = stream_context_create($opts);
    # Get the response (you can use this for GET)
    $Data = file_get_contents('https://www.atfawry.com/ECommerceWeb/Fawry/payments/charge', false, $context);
    $Data = json_decode($Data);
}

echo json_encode($Data);
