<?php

require_once 'init.php';
if ($_GET['action'] == 'get_one_acc' && $_SERVER['REQUEST_METHOD'] === 'POST') {

    if ($user_init ) {
        $get_one_acc = $UPAObj->get_one_acc($Req, $user_init['id'], $Req['lat'], $Req['lon']);
        $Data['data'] = $get_one_acc;
        $Data['success'] = true;
    } else {
        $get_one_acc = $UPAObj->get_one_acc($Req, 1, $Req['lat'], $Req['lon']);

        unset($get_one_acc['followHim']);
        unset($get_one_acc['likePage']);
        unset($get_one_acc['rate_info']['my_rate']);
        unset($get_one_acc['lat']);
        unset($get_one_acc['lon']);
        unset($get_one_acc['code']);

        $Data['data'] = $get_one_acc;
        $Data['success'] = true;

    }
} elseif ($_GET['action'] == 'getAllServices' && $_SERVER['REQUEST_METHOD'] === 'POST') {

    $parent_id = $Req['parent_id'] ? $Req['parent_id'] : '0';

    $servicesData = $UPAObj->getAllServices($parent_id);

    $Data['data'] = $servicesData;
    $Data['success'] = true;

} elseif ($_GET['action'] == 'addEdit_page_acc' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    if ($Req['services_id']) {
        if (!is_numeric($Req['mobile'])) {
            $Data['success'] = false;
            $Data['error'] = 'Mobile number should contain only digits';
        } else {
            if($user_init['page_type'] == 'page'){
                $add_page = $UPAObj->addEdit_page_acc($user_init['id'], $Req, $user_init['page_id']);
                if ($add_page) {
                    $Data['success'] = true;
                    $Data['data'] = $add_page;
                    $make_auth = $UPAObj->makeAuthCodeForPages($add_page);
                } else {
                    $Data['success'] = false;
                    $Data['error'] = 'you have page already';
                }
            }else{
                $page_id = $UPAObj->getpage_id($user_init['Have_page_id']);
                $add_page = $UPAObj->addEdit_page_acc($user_init['id'], $Req, $page_id);
                if ($add_page) {
                    $Data['success'] = true;
                    $Data['data'] = $add_page;
                    $make_auth = $UPAObj->makeAuthCodeForPages($add_page);
                } else {
                    $Data['success'] = false;
                    $Data['error'] = 'you have page already';
                }
            }
        }
    } else {
        $Data['success'] = 'false';
        $Data['error'] = 'Please select service';
    }
} elseif ($_GET['action'] == 'view_accs' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $view_accs = $UPAObj->view_accs($user_init['user_id'], $user_init['id'], $user_init['page_type']);
    $modifiedViewAccs = [];

    foreach ($view_accs as $view_acc) {
        $view_acc['not_num'] = $userObj->getUnReadNotificationNum_New($view_acc['id']);
        $modifiedViewAccs[] = $view_acc;
    }

    $Data['data'] = $modifiedViewAccs;
    $Data['success'] = 'true';
} elseif ($_GET['action'] == 'AddSharedLinkToPostsOrPages' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $data = $UPAObj->AddSharedLinkToPostsOrPages($Req);
    if($data){
        $Data['data'] = $data;
        $Data['success'] = true;
    }else{
        $Data['success'] = false;
        $Data['error'] = 'someErrorHappen';
    }
}

echo json_encode($Data);
