<?php

require_once 'init.php';
if ($_GET['action'] == 'GetAllPageAccs' && $_SERVER['REQUEST_METHOD'] === 'POST') {

    $service_id = $Req['service_id'];
    $searchKey = ($Req['searchKey']) ? $Req['searchKey'] : '';
    $start = ($Req['start']) ? $Req['start'] : 0;
    $limit = ($Req['limit']) ? $Req['limit'] : 10;
    $user_id = $user_init['id'] ? $user_init['id'] : '';
    $data = $userObj->GetAllPageAccs($Req['lat'], $Req['lon'], $service_id, $searchKey, $user_id, $start, $limit);
    if ($data) {
        $Data['data'] = $data;
        $Data['success'] = true;
    } else {
        $Data['data'] = [];
        $Data['error'] = 'noContent';
        $Data['success'] = false;
    }
} elseif ($_GET['action'] == 'getUnReadNotificationNum' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $UnReadNotificationNum = $userObj->getUnReadNotificationNum_New($user_init['id']);
    $Data['UnReadNotificationNum'] = $UnReadNotificationNum;
} elseif ($_GET['action'] == 'Auto_Login' && $_SERVER['REQUEST_METHOD'] === 'POST') {    
    if($user_init['code']){        
        if(isset($Req['social_type']) ){
            // تحويل الإصدار الحالي إلى مصفوفة
            $currentVersionArray = versionToArray(APP_VERSION);
            $result = compareVersions($currentVersionArray); 
            if ($result === -1 ) {
                echo NULL;
                exit();
            }
            $Data = $USAObj->socialLogin($Req);
            if(isset($Data['data'])){
                $signInData = $USAObj->getUserDataByID($user_init['id']);
                $Data['data'] = $signInData;
            }
        }else{
            $userInfo =isset($Req['email']) ? $USAObj->checkIfEmailExist(0, $Req['email']) : $USAObj->checkIfMobileExist($Req['mobile']);
            if (!empty($userInfo)) {
                $hash = password_verify($Req['password'], $userInfo['password']);
                if ($hash) {
                    $signInData = $USAObj->getUserDataByID($user_init['id']);
                    if ($signInData['is_deleted'] == '0') {
                        if ($signInData['active'] == '0') {
                            $Data['success'] = false;
                            $Data['error'] = "Account_Disabled";
                            $data1 = $devices->updateDevicesLoginApi($user_init['id'], $Req['device_token_id'], '0');
                            if ($user_init['page_type'] == 'page') {
                                $view_accs = $UPAObj->view_accs($user_init['user_id'], $user_init['id'], $user_init['page_type']);
                                $modifiedViewAccs = [];
        
                                foreach ($view_accs as $view_acc) {
                                    $view_acc['not_num'] = $userObj->getUnReadNotificationNum_New($view_acc['id']);
                                    $modifiedViewAccs = $view_acc;
                                }
                                $Data['data'] = $modifiedViewAccs ? $modifiedViewAccs : null;
                            }
                        } else {
                            $USAObj->updateLastLoging($userInfo['user_id']);
                            $Data['data'] = $signInData;
                            $Data['success'] = true;
                        }
                    } else {
                        $Data['success'] = false;
                        $Data['error'] = "Account_Deleted";
                        $data1 = $devices->updateDevicesLoginApi($user_init['id'], $Req['device_token_id'], '0');
                        if ($user_init['page_type'] == 'page') {
                            $view_accs = $UPAObj->view_accs($user_init['user_id'], $user_init['id'], $user_init['page_type']);
                            $modifiedViewAccs = [];
        
                            foreach ($view_accs as $view_acc) {
                                $view_acc['not_num'] = $userObj->getUnReadNotificationNum_New($view_acc['id']);
                                $modifiedViewAccs = $view_acc;
                            }
                            $Data['data'] = $modifiedViewAccs ? $modifiedViewAccs : null;
                        }
        
                    }
                } else {
                    $Data['success'] = false;
                    $Data['error'] = 'Incorrect_Password';
                }
            } else {
                $Data['success'] = false;
                $Data['error'] = 'Email_Not_Exist';
            }
        }
    }else{
        $Data['success'] = false;
        $Data['error'] = 'Incorrect_Password';
    }
} elseif ($_GET['action'] == 'edit_user' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $userInfo = ($Req['email']) ? $USAObj->checkIfEmailExist(0, $Req['email']) : $USAObj->checkIfMobileExist($Req['mobile']);
    $user = $USAObj->checkIfMobileExistForEditing($Req['mobile']);
    if(  $user &&  $user['id'] != $user_init['id']){
        $Data['success'] = false;
        $Data['error'] = 'Phone_already_exists';
        echo json_encode($Data);
        return;
    }
    if ($Req['new_password']) {
        if($Req['old_password']){
            $hash = password_verify($Req['old_password'], $userInfo['password']);
        }else{
            $hash = $Req['old_password'] == $userInfo['password'] ? 1 : 0 ;
        }
        if ($hash) {
            $hash1 = password_hash($Req['new_password'], PASSWORD_DEFAULT);
            $data = $userObj->edit_user($Req, $user_init['user_id'], $user_init['id']);
            $type = $Req['email'] ? 1 : 2;
            $USAObj->updatePassword($Req['email'] ? $Req['email'] : $Req['mobile'], $hash1,$type);
            if ($data) {
                $Data['data'] = $data;
                $Data['success'] = true;
            } else {
                $Data['error'] = 'someErrorHappen';
                $Data['success'] = false;
            }
        } else {
            $Data['success'] = false;
            $Data['error'] = 'Incorrect_Old_Password';
        }
    } else {
        $data = $userObj->edit_user($Req, $user_init['user_id'], $user_init['id']);
        if ($data) {
            $Data['data'] = $data;
            $Data['success'] = true;
        } else {
            $Data['data'] = [];
            $Data['error'] = 'someErrorHappen';
            $Data['success'] = false;
        }
    }
} elseif ($_GET['action'] == 'logOut' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $data = $devices->updateDevicesLoginApi($user_init['id'], $Req['device_token_id'], '0');
    $Data['success'] = true;
} elseif ($_GET['action'] == 'uploadImage') {

    $allow_ext = array("jpg", "gif", "png", "jpeg", "bmp");
    $maxsize = 1024 * 2; //kb
    $uploadFolder = $Config['uploads_path'] . 'services';
    $upload = new Upload($allow_ext, 0, 0, $maxsize, $uploadFolder, false);

    if (isset($_FILES['file']['name']) and $_FILES['file']['name'] != '') {

        //get file name
        $file['name'] = addslashes($_FILES["file"]["name"]);
        // get file type
        $file['type'] = $_FILES["file"]['type'];
        // get filesize in KB
        $file['size'] = $_FILES["file"]['size'] / 1024;
        // get file tmp path
        $file['tmp'] = $_FILES["file"]['tmp_name'];
        //get file ext [to get max uploades size]
        $file['ext'] = $upload->GetExt($_FILES["file"]["name"]);
        //check if guest have selected file or not
        if ($file['name'] != '') {
            // Start Uploading File
            $upfile = $upload->Upload_File($file, $maxsize);

            //if uploading successfully
            if ($upfile) {
                $temp['ImageName'] = $upfile['newname'];
                if ($_REQUEST['lastImage']) {
                    $old_image = "../uploads/services/" . $_REQUEST['lastImage'];
                }
                if (file_exists($old_image)) {
                    @unlink($old_image);
                }
            } else {
                $error = true;
                $showError[] = $upload->showErrors();
                $temp['error'] = $showError[0][0];
            }
        }
    } else {
        $temp = null;
    }

    $Data = $temp ? $temp : '';
} elseif ($_GET['action'] == 'getProfileInfoById' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $page_id = $Req['page_id'] ? $Req['page_id'] : $user_init['id'];
    $DetailsInfo = $USAObj->getUserDataByID($page_id);
    if ($DetailsInfo) {
        $user_id = $user_init['id'];
        $DetailsInfo['statistics'] = $userObj->getUserStatistics($page_id);
        if ($user_id != $page_id) {
            unset($DetailsInfo['code']);
            unset($DetailsInfo['password']);

            // if ($DetailsInfo['open_location'] != 'true') {
            //     unset($DetailsInfo['lat']);
            //     unset($DetailsInfo['lon']);
            // }
            $DetailsInfo['followHim'] = $userObj->checkifFollowingUser($user_id, $page_id);
            $DetailsInfo['blockMe'] = $userObj->checkifBlockingUser($page_id, $user_id);
            $DetailsInfo['blockHim'] = $userObj->checkifBlockingUser($user_id, $page_id);

        }
        $Data['data'] = $DetailsInfo;
        $Data['success'] = true;
    } else {
        $Data['error'] = 'accountWasDelete';
        $Data['success'] = false;
    }
} elseif ($_GET['action'] == 'followingHim' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $user_id = $user_init['id'];
    $follow_user_id = $Req['follow_user_id'];
    $blockMe = $userObj->checkifBlockingUser($follow_user_id, $user_id);
    $blockMe1 = $userObj->checkifBlockingUser($user_id, $follow_user_id);

    if ($blockMe) {
        $Data['error'] = 'this User Block Me';
        $Data['success'] = false;
    } elseif ($blockMe1) {
        $Data['error'] = 'this User Block You';
        $Data['success'] = false;
    } else {
        $res = $userObj->checkifFollowingUser($user_id, $follow_user_id);
        if ($res) {
            $data = $userObj->deleteFollowingUser($user_id, $follow_user_id);
            $Data['data'] = 'delete';
            $Data['success'] = true;
        } else {
            $data = $userObj->addFollowingUser($user_id, $follow_user_id);
            $Data['data'] = 'add';
            $Data['success'] = true;
        }
    }

} elseif ($_GET['action'] == 'blockingHim' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $user_id = $user_init['id'];
    $block_user_id = $Req['block_user_id'];
    $res = $userObj->checkifBlockingUser($user_id, $block_user_id);
    if ($res) {
        $data = $userObj->deleteBlockingUser($user_id, $block_user_id);
        $Data['data'] = 'delete';
        $Data['success'] = true;
    } else {
        if ($user_id != $block_user_id) {
            $data = $userObj->addBlockingUser($user_id, $block_user_id);
            $Data['data'] = 'add';
            $Data['success'] = true;
        }
    }
} elseif ($_GET['action'] == 'RateMe' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $user_id = $user_init['id'];
    $page_id = $Req['page_id'];
    $rate = $Req['rate'];
    $res = $userObj->checkifRatePage($user_id, $page_id);
    if ($res) {
        $data = $userObj->UpdateRatePage($user_id, $page_id, $rate);
        $Data['data'] = $data;
        $Data['success'] = true;
    } else {
        if ($user_id != $block_user_id) {
            $data = $userObj->addRatePage($user_id, $page_id, $rate);
            $Data['data'] = $data;
            $Data['success'] = true;
        }
    }
} elseif ($_GET['action'] == 'deleteImageByName' && $_SERVER['REQUEST_METHOD'] === 'POST') {

    if (!empty($Req['last_attachment'])) {
        foreach ($Req['last_attachment'] as $filename) {
            $old_img = "../uploads/posts/" . $filename;
            if (file_exists($old_img)) {
                if (@unlink($old_img)) {
                    $Data['success'][] = $filename;
                } else {
                    $Data['error'][] = $filename;
                }
            }
        }
    }

} elseif ($_GET['action'] == 'updateDevicesLangApi') {

    $data = $devices->updateDevicesLangApi($Req['user_id'], $Req['device_token_id'], $Req['lang_code']);
    if ($data) {
        $Data['success'] = true;
    } else {
        $Data['error'] = 'someErrorHappen';
        $Data['success'] = false;
    }
} elseif ($_GET['action'] == 'getreportMembersList' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    if ($Req['reportType'] == 'like') {
        $data = $postObj->getreportMembersForPost($Req['reportId'], $Req['reportType'], $Req['is_on'], $Req['start'], $Req['limit'], $Req['pin_user_id']);
    } elseif ($Req['reportType'] == 'following' || $Req['reportType'] == 'followers') {
        $data = $userObj->getreportMembersForFollowers($Req['reportId'], $Req['reportType'], $Req['start'], $Req['limit'], $Req['pin_user_id']);
    }

    if ($data) {
        $Data['data'] = $data;
        $Data['success'] = true;
    } else {
        $Data['error'] = 'noContent';
        $Data['success'] = false;
    }
} elseif ($_GET['action'] == "updateLocation" && $_SERVER['REQUEST_METHOD'] === 'POST') {

    $data = $userObj->updateLocation($user_init['id'], $Req['lat'], $Req['lon']);
    if ($data) {
        $Data['data'] = ["user_id" => $user_init['id'], "lat" => $Req['lat'], "lon" => $Req['lon']];
        $Data['success'] = true;
    } else {
        $Data['error'] = 'someErrorHappen';
        $Data['success'] = false;
    }
} elseif ($_GET['action'] == 'deleteUser' && $_SERVER['REQUEST_METHOD'] === 'POST') {
    $user_id = $user_init['id'];
    $active = $user_init['active'];
    if ($user_init['page_type'] == 'user') {

        $data1 = $devices->updateDevicesLoginApi($user_init['id'], $Req['device_token_id'], '0');
        $data = $userObj->changeStatuses($user_id, '3', $user_init['Have_page_id']);
        $date = $userObj->changeDeleteDate($user_id, 0);
        if ($data) {
            $Data['success'] = $data;
        } else {
            $Data['success'] = false;
            $Data['error'] = "failed";
        }
    } elseif ($user_init['page_type'] == 'page') {
        $data = $UPAObj->delete_acc($user_id);
        if ($data) {
            $data1 = $devices->updateDevicesLoginApi($user_init['id'], $Req['device_token_id'], '0');
            $view_accs = $UPAObj->view_accs($user_init['user_id'], $user_init['id'], $user_init['page_type']);
            $modifiedViewAccs = [];

            foreach ($view_accs as $view_acc) {
                $view_acc['not_num'] = $userObj->getUnReadNotificationNum_New($view_acc['id']);
                $modifiedViewAccs = $view_acc;
            }

            $Data['data'] = $modifiedViewAccs;
            $Data['success'] = true;
        } else {
            $Data['error'] = 'noContent';
        }
    }
}

echo json_encode($Data);