<?php

$message = new message();

class message
{

    public $mDb;
    public $notification;
    public $mMailer;
    public $prefix;
    public $mConfig;
    public $lang;
    public $dateTime;

    public function message()
    {
        
        $this->mDb = new iplus();
        $this->notification = new notifications();
        $this->mMailer = new Mailer();
        $this->mMailer->mConfig = $Config;
        $this->prefix = $Config['prefix'];
        $this->mConfig = $Config;
        $this->lang = LANGUAGE;
        $this->dateTime = date('Y-m-d H:i:s');
    }

    public function trim_text($input_1, $length, $strip_html = true)
    {
        //strip tags, if desired
        if ($strip_html) {
            $input_1 = strip_tags($input_1);
        }
        //no need to trim, already shorter than trim length
        if (mb_strlen($input_1, 'UTF-8') <= $length) {
            return $input_1;
        }
        $last_space = mb_strrpos(mb_substr($input_1, 0, $length, "utf-8"), ' ', "utf-8");
        //    echo $last_space . "<hr>";
        $last_space ? $last_space = $last_space : $last_space = $length;

        $trimmed_text = mb_substr($input_1, 0, $last_space, "utf-8");
        return $trimmed_text . ' ...';
    }
    public function getTitleOfMessageByType($type, $id)
    {
        if ($type == 'order') {
            $sql = "SELECT order_title FROM`{$this->mPrefix}service_orders` ";
            $sql .= "WHERE id = '{$id}' ";
        } else if ($type == 'post') {
            $sql = "SELECT `description` FROM`{$this->mPrefix}posts` ";
            $sql .= "WHERE id = '{$id}' ";
        }
        return $this->mDb->getOne($sql);

    }
    public function getAllConversationByUserIdApi($aId =0 , $conversationType= null, $aStart = 0, $aLimit = 0, $aTo = 0)
    {
        $sql = "SELECT C.`id`,C.`user1`,C.`user2`,C.`url` ,	C.`conversation_type`  FROM`{$this->mPrefix}conversation` C ";
        $sql .= " LEFT JOIN `{$this->mPrefix}users` U1 ON (U1.id = C.user1  ) ";
        $sql .= " LEFT JOIN `{$this->mPrefix}users` U2 ON (U2.id = C.user2  ) ";
        $sql .= " LEFT JOIN `{$this->mPrefix}messages` M ON (C.`id` = M.`conversation_id`) ";
        $sql .= "WHERE (C.`user1`='{$aId}' or C.user2='{$aId}') AND M.id > 0  AND U1.`active`='1' AND U2.`active`='1' ";
        $sql .= $aTo ? " AND(C.`user1`!='{$aTo}' AND C.`user2`!='{$aTo}' ) " :  " ";
        $sql .=" GROUP BY   C.`id` " ;
        $sql .=   " order by last_updated desc " ;
        // $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        //  echo $sql;die();
        $res = $this->mDb->getAll($sql);
        if ($res) {
            $count = count($res);
          //  echo $count;
            for ($i = 0; $i < $count; $i++) {
                if ($res[$i]['conversation_type'] != 'public') {
                     //   echo $res[$i]['conversation_type'] .'==';
                    $res[$i]['title'] = $this->getTitleOfMessageByType($res[$i]['conversation_type'], $res[$i]['url']);
                }
                $info = $this->getLastMessageInfoInConverstationApi($res[$i]['id'], $aId);
              // echo "<pre>";   print_r($info);
                if ($info['date_added']) {
                    $reciver_id = $res[$i]['user1'] == $aId ? $res[$i]['user2'] : $res[$i]['user1'];

                    $Reciver = $this->getReciverInfoByIdApi($reciver_id);
                    $res[$i]['unreadMessageCount'] = $this->getUnreadMessageCountApi($aId, $res[$i]['id']);
                    $res[$i]['seen_it'] = $info['seen_it'];
                    $res[$i]['type'] = $info['type'];
                    $res[$i]['date_added'] = $info['date_added'];
                    $res[$i]['messageType'] = $info['senderMessage'] == $aId ? 'send' : 'recive';
                    $res[$i]['message'] = $this->trim_text($info['message'], 30);
                    $res[$i]['trusted'] = $Reciver['trusted'];
                    $res[$i]['user_name'] = $Reciver['user_name'];

                    $res[$i]['avatar'] = $Reciver['avatar'];
                    $res[$i]['to'] = $reciver_id;

                    unset($res[$i]['user1'], $res[$i]['user2']);
                } else {
                    unset($res[$i]);
                }

            }
            // die();
            // echo "<pre>";   print_r($res);die();
            # code...

            //die();

  
            

        }
        $ret['conversations'] = array_values($res);

        $ret['count'] = $count;
        return $ret;
    }

    public function getReciverInfoByIdApi($aId)
    {
        $sql = " SELECT user_name,avatar  ,trusted ";
        $sql .= " FROM `{$this->mPrefix}users` ";
        $sql .= " WHERE `id`='$aId' ";
        // echo "$sql";die();
        return $this->mDb->getRow($sql);
    }

    public function getLastMessageInfoInConverstationApi($conversation_id =0 , $aUserId =0)
    {

        $deleteConversationDate = $this->getDeleteDateByConversation_idAndUser_id($conversation_id, $aUserId);
$deleteConversationDate=$deleteConversationDate?$deleteConversationDate:'1970-01-01';
        //  echo $sql;die();
        $sql = "SELECT m.message,m.date_added ,m.seen_it ,m.from as senderMessage ,m.type    FROM `{$this->mPrefix}messages` m";
        $sql .= " WHERE m.`conversation_id` = '{$conversation_id}' AND m.`date_added` > '{$deleteConversationDate}' and (m.`from`='{$aUserId}' and m.to !='{$aUserId}' and m.del_from ='0' or m.`from` !='{$aUserId}' and m.to ='{$aUserId}' and m.del_to ='0')";
        $sql .= " ORDER BY m.`id` DESC";
        $sql .= " LIMIT 1 ";
//echo $sql;
        $res = $this->mDb->getRow($sql);
        //echo "<pre>";print_r($res);die();
        return $res;
    }

    // function getLastMessageForMeSeen($conversation_id, $aUserId) {
    //     $sql = "SELECT conversation_id, seen_it FROM `{$this->mPrefix}messages`";
    //     $sql.= " WHERE `conversation_id` = '{$conversation_id}'";
    //     $sql.= " AND `from` !='{$aUserId}' AND del_from ='0'";
    //     $sql.= " ORDER BY `id` DESC";
    //     $sql.= " LIMIT 1 ";
    //     //echo $sql;//die();
    //     $res = $this->mDb->getRow($sql);
    //     if ($res['conversation_id']) {
    //         $seen = $res['seen_it'];
    //     }else{
    //         $seen = '';
    //     }
    //     return  $seen;
    // }
    public function checkIfConversationApi($temp)
    {
        $sql = " SELECT id FROM `{$this->mPrefix}conversation`  ";
        $sql .= " WHERE (`user1`='{$temp['user_id']}' and user2='{$temp['user2']}' or `user1`='{$temp['user2']}' and user2='{$temp['user_id']}')  AND  conversation_type = '{$temp['conversation_type']}' ";
        $sql .= $temp['url'] ? "AND `url` = '{$temp['url']}' " : " ";

        //echo $sql;die();
        $id = $this->mDb->getOne($sql);
        if ($id) {
            $msgs = $this->showMessagesInfoBetweenMeAndYouApi($id, $temp['user_id']);
            if ($msgs) {
                $res['data'] = $msgs;
            } else {
                $res['convId'] = $id;
            }
            return $res;
        } else {
            return false;
        }

    }

    public function showMessagesInfoBetweenMeAndYouApi($conversation_id =0 , $aUserId= 0, $aStart = 0, $aLimit = 0)
    {
        
        
        //global $Config;
        $deleteConversationDate = $this->getDeleteDateByConversation_idAndUser_id($conversation_id, $aUserId);
        $deleteConversationDate=$deleteConversationDate?$deleteConversationDate:'1970-01-01';

        //   echo "$deleteConversationDate";die();
        $sql = "SELECT M.id,M.conversation_id,M.`from`,M.`to`,M.message,M.direction,M.type,M.seen_it,M.unique_,M.date_added ,SO.active FROM  `{$this->prefix}messages` as M ";
        $sql .= " LEFT JOIN `{$this->mPrefix}conversation` C ON (C.`id` = M.`conversation_id`) ";
        $sql .= " LEFT JOIN `{$this->mPrefix}service_orders` SO ON (SO.`id` = C.`url`) ";

        $sql .= "WHERE M.`conversation_id` ='{$conversation_id}' AND M.`date_added` > '{$deleteConversationDate}'  ";
        // echo $sql;die();
        /*$sql.=$id ? " and `m`.`id` ='{$id}'" : "";
        $sql.=$lastId ? " and `m`.`id`>'{$lastId}'" : "";
        $sql .=") or (`m`.`to` ='{$from}' && `m`.`from` ='{$to}' && `m`.`del_to` ='0'";
        $sql.=$id ? " and `m`.`id` ='{$id}'" : "";
        $sql.=$lastId ? " and `m`.`id`>'{$lastId}'" : "";
        $sql .=")";
        $sql.=$id ? " and `m`.`conversation_id` ='{$coversation_id}'" : "";*/
        $sql .= "ORDER BY M.`id` DESC ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        //$sql.= $offset && !$lastId ? "LIMIT {$sIndex},{$offset}" : '';
        //  echo $sql;die();
        $res = $this->mDb->getAll($sql);
        $res = array_reverse($res);
        if ($res) {
            $this->updateMsgSeenIt($conversation_id, $aUserId);
        }
        $res=array_reverse($res);
        // print_r($res);
        return $res;
    }
     public function showMessagesInfo($conversation_id = 0, $aUserId = 0, $aStart = 0, $aLimit = 0)
    {
        
        
        //global $Config;
       // $deleteConversationDate = $this->getDeleteDateByConversation_idAndUser_id($conversation_id, $aUserId);
        //   echo "$deleteConversationDate";die();
        $sql = "SELECT uf.user_name usernamefrom ,uf.avatar avatarfrom,M.id,M.conversation_id,M.`from`,M.`to`,M.message,M.direction,M.type,M.seen_it,M.unique_,M.date_added ,SO.active FROM  `{$this->prefix}messages` as M ";
        $sql .= " LEFT JOIN `{$this->mPrefix}conversation` C ON (C.`id` = M.`conversation_id`) ";
        $sql .= " LEFT JOIN `{$this->mPrefix}service_orders` SO ON (SO.`id` = C.`url`) ";
       // $sql .= " LEFT JOIN `{$this->mPrefix}users` ut ON (ut.`id` = M.`to`) ";
        $sql .= " LEFT JOIN `{$this->mPrefix}users` uf ON (uf.`id` = M.`from`) ";
        $sql .= "WHERE M.`conversation_id` ='{$conversation_id}'  ";
        //echo $sql;die();
        /*$sql.=$id ? " and `m`.`id` ='{$id}'" : "";
        $sql.=$lastId ? " and `m`.`id`>'{$lastId}'" : "";
        $sql .=") or (`m`.`to` ='{$from}' && `m`.`from` ='{$to}' && `m`.`del_to` ='0'";
        $sql.=$id ? " and `m`.`id` ='{$id}'" : "";
        $sql.=$lastId ? " and `m`.`id`>'{$lastId}'" : "";
        $sql .=")";
        $sql.=$id ? " and `m`.`conversation_id` ='{$coversation_id}'" : "";*/
        $sql .= "ORDER BY M.`id` DESC ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        //$sql.= $offset && !$lastId ? "LIMIT {$sIndex},{$offset}" : '';
     //  echo $sql;die();
        $res = $this->mDb->getAll($sql);
        $res = array_reverse($res);
       
        
        // print_r($res);
        return $res;
    }
    public function getDeleteDateByConversation_idAndUser_id($conversation_id = 0, $aUserId = 0)
    {
        $sql = $this->getUser1ByConversationId($conversation_id) == $aUserId ? " SELECT date_delete_form_user1   " : " SELECT date_delete_form_user2   ";
        $sql .= "  FROM `{$this->mPrefix}conversation`  WHERE  id = '{$conversation_id}' ";
//   echo "$sql";
        return $this->mDb->getOne($sql);

    }
    public function getLiveMessagesApi($conversation_id = 0 , $aUserId = 0, $alimit = 10)
    {
        //global $Config;
        $deleteConversationDate = $this->getDeleteDateByConversation_idAndUser_id($conversation_id, $aUserId);
        $deleteConversationDate=$deleteConversationDate?$deleteConversationDate:'1970-01-01';

        // echo $deleteConversationDate ;die();
        $sql = "SELECT M.id,M.conversation_id,M.`from`,M.`to`,M.message,M.direction,M.type,M.seen_it,M.unique_,M.date_added FROM  `{$this->prefix}messages` as M ";
        $sql .= "WHERE M.`conversation_id` ='{$conversation_id}' AND M.`date_added` > '{$deleteConversationDate}' ";
        $sql .= $aLastId ? " AND M.`id`>'{$aLastId}'" : ""; // for live push msg
        //$sql.=$aFrom ? " AND M.`from` = '{$aFrom}'" : ""; // for live push msg
        $sql .= "ORDER BY M.`id` desc LIMIT {$alimit}   ";
        // echo $sql;die();
        $res = $this->mDb->getAll($sql);
        if ($res) {
            $this->updateMsgSeenIt($conversation_id, $aUserId);
        }
        return $res;
    }

    public function updateMsgSeenIt($conversation_id = 0, $aUserId = 0)
    {
        $sql = "UPDATE `{$this->mPrefix}messages` SET";
        $sql .= " seen_it = '1' ";
        $sql .= " WHERE `to` = '{$aUserId}' AND  `seen_it` = '0' AND  `conversation_id` = '{$conversation_id}'   ";
        // echo $sql."<br>" ;
        return $this->mDb->query($sql);
    }

// emad code

public function getMyConversationId($aUserId  ,$from = 0,$to = 0,$order_id= 0,$post_id=0)
    {

        if($order_id && $order_id >0){
            
            $sql = "SELECT `id` FROM `{$this->mPrefix}conversation`";
            $sql .= " WHERE  (`user1` = '{$from}' AND `user2` = '{$to}' AND `order_id` = '{$order_id}' ) OR (`user1` = '{$to}' AND `user2` = '{$from}' AND `order_id` = '{$order_id}' )";
            $conid = $this->mDb->getOne($sql);
        //  echo $conid;
           if($conid && $conid >0){
              
                return $conid;
            }
            else{
                $sql = "INSERT INTO `{$this->prefix}conversation` SET ";
                $sql .= " user1='{$from}', user2='{$to}', conversation_type='order' ,";
                $sql .= " url='{$order_id}',";
                $sql .= " order_id='{$order_id}',";
                $sql .= " last_updated=NOW(),";
                $sql .= " date_added=NOW()";
                //  echo $sql;die();
              return  $this->mDb->queryreturnlastid($sql);
            }
        } 
        elseif($post_id && $post_id >0){
            
              
            $sql = "SELECT `id` FROM `{$this->mPrefix}conversation`";
            $sql .= " WHERE  (`user1` = '{$from}' AND `user2` = '{$to}' AND `url` = '{$post_id}' ) OR (`user1` = '{$to}' AND `user2` = '{$from}' AND `url` = '{$post_id}' )";
            $conid = $this->mDb->getOne($sql);
            if($conid && $conid >0){
                return $conid;
            }
            else{
                $sql = "INSERT INTO `{$this->prefix}conversation` SET ";
                $sql .= " user1='{$from}', user2='{$to}', conversation_type='post' ,";
                $sql .= " url='{$post_id}',";
                $sql .= " last_updated=NOW(),";
                $sql .= " date_added=NOW()";
                //echo $sql;die();
              return  $this->mDb->queryreturnlastid($sql);
            }
            
        }
        else{
            
            $sql = "SELECT `id` FROM `{$this->mPrefix}conversation`";
            $sql .= " WHERE  (`user1` = '{$from}' AND `user2` = '{$to}' ) OR (`user1` = '{$to}' AND `user2` = '{$from}' )";
            $conid = $this->mDb->getOne($sql);
            if($conid && $conid >0){
                return $conid;
            }
            else{
                $sql = "INSERT INTO `{$this->prefix}conversation` SET ";
                $sql .= " user1='{$from}', user2='{$to}', conversation_type='public' , ";
                $sql .= " last_updated=NOW(),";
                $sql .= " date_added=NOW()";
                //echo $sql;die();
              return  $this->mDb->queryreturnlastid($sql);
            }
        }
    }
    
   public  function messageHasSeen($requist) {
        
       $sql = "update `messages` set ";
         $sql .= "`seen_it` = '1' ";
         $sql .= "where `id`='{$requist['id']}'";
         // echo $sql;die();
         if($this->mDb->query($sql)){
              return $this->getMessage($requist);
         }
    }
    
     public  function getMessage($requist) {
           
           
        $sql = "SELECT m.`id`,m.`conversation_id`,m.`unique_`,m.message,m.date_added ,m.seen_it ,m.from,m.`direction`,m.`to` ,m.type ,u.`avatar`,u.`user_name`  ,u.`trusted` as 'full_name'  FROM `{$this->mPrefix}messages` m";
         $sql .= " LEFT JOIN `users` u ON m.`from` = u.`id` ";
        $sql .= " WHERE m.`id` = '{$requist['id']}'";
        $sql .= " LIMIT 1 ";

        $res = $this->mDb->getRow($sql);
        //echo "<pre>";print_r($res);die();
        return $res;
       
    }

    public function addConversationApi($temp)
    {

        $sql = "INSERT INTO `{$this->prefix}conversation` SET ";
        $sql .= " user1='{$temp['from']}', user2='{$temp['to']}', conversation_type='{$temp['conversation_type']}',";

        $sql .= $temp['url'] ? " url='{$temp['url']}'," : ' ';

        $sql .= " last_updated=NOW(),";
        $sql .= " date_added=NOW()";
    // echo $sql;die();
        $this->mDb->query($sql);
        $lastId = $this->mDb->getLastInsertId();
        if ($lastId) {
            $temp['conversation_id'] = $lastId;
            return $this->insertMessageApi($temp);
        }
    }
  public  function getMyConversationType($from=null,$to=null,$aStart = 0, $aLimit = 0) {
           
           
        $sql = "SELECT m.id,m.message,m.date_added ,m.seen_it ,m.from,m.`to` ,m.type ,m.conversation_id, c.* ,m.date_added FROM `{$this->mPrefix}messages` m";
       //  $sql .= " LEFT JOIN `users` u ON m.`from` = u.`id` ";
        $sql .= " LEFT JOIN `conversation` c ON c.`id` = m.`conversation_id` ";
        $sql .= " WHERE m.`type` = 'image'  ";
        $sql .= " ORDER BY m.id desc ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

       // $sql .= " LIMIT 1 ";
//echo $sql;die();
        $res = $this->mDb->getAll($sql);
    //  echo "<pre>";print_r($sql);die();
        return $res;
       
    }
        public function insertMessageApi($temp)
    {

 
        //echo "<pre>"; print_r($temp); die();
        //$time = date("Y-m-d H:i:s");
        /*$co_id = $this->getConversation($temp);
        if ($co_id) {
        $temp['conversation_id'] = $co_id;
        } else {
        $temp['conversation_id'] = $this->addConversation($temp);
        }*/
        
        if($temp['recever_in_room'] === false){
                                                                      
   
              $temp['notificationType']='message';
               $Reciver = $this->getReciverInfoByIdApi($temp['user_id']);
            $addNotSend['send_user_id'] = $temp['user_id'];
            $addNotSend['page_type'] = $temp['notificationType'];
            $addNotSend['receive_user_id'] = $temp['to'];
            $addNotSend['url'] = $temp['conversation_id'];
            $addNotSend['to'] = $temp['user_id'];
            
            $addNotSend['url_'] = $temp['url'] ? $temp['url'] : 'null';
            $addNotSend['order_title'] = $this->getConversationType($temp['conversation_id']);
            $addNotSend['order_id'] = $addNotSend['order_title'] =='post' || $addNotSend['order_title'] =='order' ? $this->getConversationOrderIdOrPostID($addNotSend['order_title'],$temp['conversation_id']) : '';
            $addNotSend['avatar'] = $Reciver['avatar'];
            $addNotSend['user_name'] = $Reciver['user_name'];
            $addNotSend['content'] = $temp['message'];
            
            $this->notification->sendNewNotification($addNotSend);
            
        }
        
        $sql = "INSERT INTO `{$this->prefix}messages` SET ";
        foreach ($temp as $k => $v) {
             if($k == 'date_added'){
                if($v && $v > 0) {
                }else{
                 $v=$this->dateTime;
                }
            }
            $sql .= ($k == 'user_id' || $k == 'conversation_type' || $k == 'url' || $k == 'cachFile' || $k == 'progress' || $k == 'uploadLoader'|| $k == 'recever_in_room' || $k == 'notificationType') ? "" : "`{$k}`='{$v}',";
        }
        $sql = substr($sql, 0, -1);

        //  echo $sql;die();
        $row = $this->mDb->query($sql);
        if ($row) {
            $id = $this->mDb->getLastInsertId();
            $this->updateConversationApi($temp['conversation_id']);

            return  $this->getOneMessage($id);
        } else {
            return false;
        }
    }
    
    public function getConversationType($conversation_id)
    {
        $sql = " SELECT  conversation_type   FROM `{$this->mPrefix}conversation` ";
        $sql .= " WHERE `id` =  '{$conversation_id}' ";
        // echo " $sql";
        
        return $this->mDb->getOne($sql);
    }
    
     public function getConversationOrderIdOrPostID($type, $conversation_id)
    {
        if($type == 'order'){
             $sql = " SELECT  order_id   FROM `{$this->mPrefix}conversation` ";
            $sql .= " WHERE `id` =  '{$conversation_id}' ";
        // echo " $sql";
        
        return $this->mDb->getOne($sql);
        }else{
              $sql = " SELECT  url   FROM `{$this->mPrefix}conversation` ";
            $sql .= " WHERE `id` =  '{$conversation_id}' ";
        // echo " $sql";
        
        return $this->mDb->getOne($sql);
        }
       
    }
    
    
    

    public function updateConversationApi($id)
    {

        $sql = "UPDATE `{$this->mPrefix}conversation` SET ";
        $sql .= " last_updated=NOW()";
        $sql .= " WHERE `id`='$id' ";
        //echo $sql . "<hr>";
        return $this->mDb->query($sql);
    }
    
     public function getOneMessage($id)
    {
        
        $sql = "SELECT m.`id`,m.`conversation_id`,m.`unique_`,m.message,m.date_added ,m.seen_it ,m.from,m.`direction`,m.`to` ,m.type    FROM `{$this->mPrefix}messages` m";
        $sql .= " WHERE m.`id` = '{$id}'";
        $sql .= " LIMIT 1 ";

        $res = $this->mDb->getRow($sql);
        //echo "<pre>";print_r($res);die();
        return $res;
        
    }

    public function getUnreadMessageCountApi($aUserId, $conversation_id)
    {
        $sql = " SELECT count(id)  FROM `{$this->mPrefix}messages`";
        $sql .= " WHERE `to` = '{$aUserId}'";
        $sql .= " AND `seen_it` = '0'";
        $sql .= $conversation_id ? " AND conversation_id ='{$conversation_id}'   " : " ";
        // $sql .= " GROUP BY `conversation_id`";
      //  echo $sql; die();
      $ress=$this->mDb->getOne($sql);
        return $ress ? $ress :"0";
    }
    public function cheackBlocked($user_id, $user_blocked_id)
    {
        $sql = " SELECT user_id FROM `{$this->mPrefix}coversation_blocks`";
        $sql .= " WHERE  (`user_id` = '{$user_id}'  AND  `user_blocked_id` = '{$user_blocked_id}' ) || (`user_id` = '{$user_blocked_id}'  AND  `user_blocked_id` = '{$user_id}') ";
        //echo $sql; die();
        return $this->mDb->getAll($sql);

    }

    public function checkifBlockUser($user_id, $user_blocked_id)
    {
        $sql = " SELECT  id   FROM `{$this->mPrefix}coversation_blocks` ";
        $sql .= " WHERE `user_id` =  '{$user_id}' AND  `user_blocked_id` =  '{$user_blocked_id}'    ";
        // echo " $sql";
        $res = $this->mDb->getOne($sql) ? true : false;
        return $res;
    }
    public function deleteBlockUser($user_id, $user_blocked_id)
    {
        $sql = "DELETE  FROM `{$this->mPrefix}coversation_blocks`   ";
        $sql .= " WHERE `user_id` =  '{$user_id}' AND  `user_blocked_id` =  '{$user_blocked_id}'    ";

        // echo "$sql";
        return $this->mDb->query($sql);

    }
    public function addBlockUser($request)
    {
        $sql = "INSERT INTO `coversation_blocks` SET ";
        foreach ($request as $k => $v) {
            $sql .= ($k == 'id') ? "" : "`{$k}`='{$v}',";
        }

        $sql .= " `date_added` = NOW() ";
        // echo $sql; die();
        return $this->mDb->query($sql);
    }
    public function deleteConversation($conversation_id, $user_id)
    {

        $sql = "UPDATE `{$this->mPrefix}conversation` SET ";
        $sql .= $this->getUser1ByConversationId($conversation_id) == $user_id ? " date_delete_form_user1=NOW() " : "date_delete_form_user2=NOW() ";
        $sql .= " WHERE `id`='{$conversation_id}' ";
        //echo $sql . "<hr>";
        return $this->mDb->query($sql);
    }
    public function getUser1ByConversationId($conversation_id)
    {
        $sql = " SELECT user1   FROM `{$this->mPrefix}conversation`  ";
        $sql .= " WHERE  id = '{$conversation_id}' ";
        return $this->mDb->getOne($sql);

    }
      //sec 
    public function cheackIfUserRelatedToConversion($user_id, $conversation_id)
    {
        $sql = " SELECT id   FROM `{$this->mPrefix}conversation`  ";
        $sql .= " WHERE  id = '{$conversation_id}' AND (user1 = '{$user_id}' || user2 = '{$user_id}' ) ";
        // echo $sql; 
        return $this->mDb->getOne($sql);
    }

}
