<?php

/* * *************************************************************************
 *
 *   PROJECT: Ubzil App
 *   powerd by IT PLUS Team
 *   Copyright 2017 IT Plus Inc
 *   http://it-plus.co/
 *
 * ************************************************************************* */
require_once('init.php');

// Start Functionality  
$apache_request = apache_request_headers();


if ($_GET['action'] == 'getAllConversation') {

   $userStatus = $userObj->getStatusByUserId($Req['user_id']);
   if ($userStatus['active'] == '1') {
      $data = $message->getAllConversationByUserIdApi($Req['user_id'], $Req['conversationType'], $Req['start'], $Req['limit'], 0);
      if ($data) {
         $Data['data'] = $data;
      } else {
         $Data['error'] = 'noContent';
      }
   } else {
      $Data['error'] = 'noContent';
   }
} else if ($_GET['action'] == 'messageHasSeen') {
   $data = $message->messageHasSeen($Req);

   if ($data) {
      $Data['data'] = $data;
   } else {
      $Data['error'] = 'noContent';
   }
} else if ($_GET['action'] == 'getConversationMessages') {
   $data = $message->showMessagesInfoBetweenMeAndYouApi($Req['conversation_id'], $Req['user_id'], $Req['start'], $Req['limit']);

   if ($data) {
      $Data['data'] = $data;
      $Data['blockedArray'] = $message->cheackBlocked($Req['user_id'], $Req['to']);
   } else {
      $Data['error'] = 'noContent';
      $Data['blockedArray'] = $message->cheackBlocked($Req['user_id'], $Req['to']);
   }
} else if ($_GET['action'] == 'getConversationMessagesAll') {
   $data = $message->showMessagesInfo($Req['conversation_id'], $Req['user_id'], $Req['start'], $Req['limit']);

   if ($data) {
      $Data['data'] = $data;
      $Data['blockedArray'] = $message->cheackBlocked($Req['user_id'], $Req['to']);
   } else {
      $Data['error'] = 'noContent';
      $Data['blockedArray'] = $message->cheackBlocked($Req['user_id'], $Req['to']);
   }
} else if ($_GET['action'] == 'deleteConversation') {
   $data = $message->deleteConversation($Req['conversation_id'], $Req['user_id']);
   if ($data) {
      $Data['data'] = $data;
   } else {
      $Data['error'] = true;
   }
} else if ($_GET['action'] == 'getLiveMessages') {
   $data = $message->getLiveMessagesApi($Req['conversation_id'], $Req['user_id'], $Req['limit']);
   if ($data) {
      $Data['data'] = $data;
      $Data['blockedArray'] = $message->cheackBlocked($Req['user_id'], $Req['to']);
   } else {
      $Data['error'] = 'noContent';
      $Data['blockedArray'] = $message->cheackBlocked($Req['user_id'], $Req['to']);
   }
} else if ($_GET['action'] == 'checkIfConversation') {
   $data = $message->checkIfConversationApi($Req);
   $Data = [
      'convId'  => $data['convId'],
      'data'    => $data['data']
   ];
   //print_r($Data);die();
   //$Data  = $data? $data :'';
} else if ($_GET['action'] == 'getMyConversationId') {

   $userStatus = $userObj->getStatusByUserId($Req['from']);
   if ($userStatus['active'] == '1') {
      $order_id = $Req['order_id'] ? $Req['order_id'] : '';
      $post_id = $Req['post_id'] ? $Req['post_id'] : '';
      $from = $Req['from'];
      $to = $Req['to'];


      $data = $message->getMyConversationId("",$from, $to, $order_id, $post_id);

      if ($data) {
         $Data['data'] = $data;
      } else {
         $Data['error'] = 'noContent';
      }
   } else {
      $Data['error'] = 'noContent';
   }
} else if ($_GET['action'] == 'addConversation') {
 
      $res =   $message->checkifBlockUser($Req['to'], $Req['from']);

      if (!$res) {
         if ($Req['type'] == 'image' || $Req['type'] == 'voice') {

            $name = md5(time() . uniqid());
            $uploadmessagesFolder = $_SERVER['DOCUMENT_ROOT'] . '/' . 'api/uploads/chats/';
            $filename = $Req['type'] == 'image' ? $name . ".jpg" : $name . ".3gp";
            $fullpath = $uploadmessagesFolder . $filename;


            $image = $Req['message'];
            $status = file_put_contents($fullpath, base64_decode($image));
            if ($status) {
               $Req['message'] = $filename;
            } else {
            }
         }

         if (!$Req['conversation_id']) {

            $data = $message->addConversationApi($Req);
         } else {
            $data = $message->insertMessageApi($Req);
         }

         if ($data) {
            $Data['data'] = $data;


        //   $Data['conversations'] =  $message->getAllConversationByUserIdApi($Req['to'], $Req['conversationType'], $Req['start'], $Req['limit'], 0);
           $Data['conversations'] =  "";
         } else {
            $Data['error'] = 'noContent';
         }
      } else {
         $Data['error'] = 'blocked';
      }
   
} else if ($_GET['action'] == 'getMyConversationType') {


   $order_id = $Req['user_id'] ? $Req['user_id'] : '';
   $post_id = $Req['post_id'] ? $Req['post_id'] : '';
   $from = $Req['from'];
   $to = $Req['to'];

   $data = $message->getMyConversationType($from, $to, $Req['start'], $Req['limit']);

   if ($data) {
      $Data['data'] = $data;
   } else {
      $Data['error'] = 'noContent';
   }
} else if ($_GET['action'] == 'getUnreadMsgCount') {

   $data =  $message->getUnreadMessageCountApi($Req['user_id']);
   if ($data) {
      $Data['data'] = $data;
   } else {
      $Data['error'] = 'noContent';
   }
} elseif ($_GET['action'] == 'checkifBlockingUser') {
   $Data['data']  = $message->checkifBlockUser($Req['chat_user_id'], $Req['user_id']);
} elseif ($_GET['action'] == 'checkstatusBlockingUser') {
   $Data['data']  = $message->checkifBlockUser($Req['user_id'], $Req['chat_user_id']);
} elseif ($_GET['action'] == 'blockOrUnblock') {
   $res =   $message->checkifBlockUser($Req['user_id'], $Req['user_blocked_id']);
   //res => true or false ;
   // echo "$res";die();
   if ($res) {
      $data = $message->deleteBlockUser($Req['user_id'], $Req['user_blocked_id']);
      $Data['data'] = 'delete';
      # code...
   } else {
      $data = $message->addBlockUser($Req);
      $Data['data'] = 'add';

      # code...
   }
}


echo json_encode($Data);
